<script lang="ts">
  import { getContext } from 'svelte'
  import { Character } from '../../../module/character/character.js'

  import { getLocalizer } from '../../../module/utils.js'
  import Dialog from '../../Dialog.svelte'
  import Select from '../../Select.svelte'
  import Roll from '../../roll-dialog/Roll.svelte'

  import CombatStatBlock from './CombatStatBlock.svelte'
  import { CharacterDataAccessor } from '../../../module/model/character.js'
  import { Writable } from 'svelte/store'
  import { createEventDispatcher } from 'svelte'
  import { hasName } from '../../../module/model/utils.js'

  const dispatch = createEventDispatcher()

  const localize = getLocalizer()

  let doc = getContext<Writable<CharacterDataAccessor>>('doc')
  $: character = new Character($doc)
  $: weapons = $doc.weapons
  $: shields = $doc.shields
  $: unarmedTalents = $doc.talents.filter(
    (talent) =>
      talent.type === 'combatTalent' &&
      talent.system.combat.category === 'unarmed'
  )

  const noneOption = {
    label: localize('none'),
    value: undefined,
    group: undefined,
  }

  $: primaryHandOptions = [
    noneOption,
    ...weapons.filter(hasName).map((weapon) => ({
      label: weapon.name,
      value: weapon.id as any,
      group: weapon.type as any,
    })),
  ]

  $: secondaryHandOptions = [
    noneOption,
    ...[...weapons, ...shields].filter(hasName).map((weapon) => ({
      label: weapon.name,
      value: weapon.id as any,
      group: weapon.type as any,
    })),
  ]

  $: unarmedTalentOptions = [
    noneOption,
    ...unarmedTalents.filter(hasName).map((talent) => ({
      label: talent.name,
      value: talent.id as any,
      group: talent.type as any,
    })),
  ]

  $: primaryHand = $doc.combatState.primaryHand
  $: secondaryHand = $doc.combatState.secondaryHand
  $: isArmed = $doc.combatState.isArmed
  $: unarmedTalent = $doc.combatState.unarmedTalent

  function toggleUnarmed() {
    $doc.system.base.combatState.isArmed = !$doc.system.base.combatState.isArmed
    dispatch('change')
  }

  let dodgeRollDialog

  function rollDodge(modifiers) {
    character.dodge({
      modifiers,
    })
  }
</script>

<Dialog
  bind:this={dodgeRollDialog}
  title={localize('dodge')}
  dialogComponent={Roll}
  callback={rollDodge}
/>

<!-- svelte-ignore a11y-click-events-have-key-events a11y-no-static-element-interactions a11y-missing-attribute -->
<a class="unarmedToggle" on:click={toggleUnarmed}>
  <i class="fas fa-gavel" />
  {#if isArmed}
    <i class="fas fa-toggle-off" />
  {:else}
    <i class="fas fa-toggle-on" />
  {/if}
  <i class="fas fa-fist-raised" />
</a>
<div class="flexrow">
  {#if isArmed}
    <div data-testid="primary-hand-options">
      {localize('primaryHand')}
      <Select
        items={primaryHandOptions}
        bind:value={$doc.system.base.combatState.primaryHand}
      />
    </div>
    <div data-testid="secondary-hand-options">
      {localize('secondaryHand')}
      <Select
        items={secondaryHandOptions}
        bind:value={$doc.system.base.combatState.secondaryHand}
      />
    </div>
  {:else}
    <div data-testid="unarmed-talent-options">
      {localize('unarmedTalent')}
      <Select
        items={unarmedTalentOptions}
        bind:value={$doc.system.base.combatState.unarmedTalent}
      />
    </div>
  {/if}
  <div class="initiative" data-testid="initiative">
    <div class="combat-attribute-label">
      {localize('initiative')}
    </div>
    <div class="combat-attribute-value">
      {character.initiative().formula}
    </div>
  </div>
</div>
<div data-testid="combat-stats">
  {#if isArmed}
    {#if primaryHand !== undefined}
      <CombatStatBlock weapon={primaryHand} />
    {/if}
    {#if secondaryHand !== undefined}
      <CombatStatBlock weapon={secondaryHand} isSecondary={true} />
    {/if}
  {:else if unarmedTalent !== undefined}
    <CombatStatBlock
      weapon={unarmedTalent}
      isSecondary={false}
      isArmed={false}
    />
  {/if}
</div>

<div class="combat-attributes">
  <!-- svelte-ignore a11y-click-events-have-key-events a11y-no-static-element-interactions a11y-missing-attribute -->
  <a on:click={dodgeRollDialog.open} data-testid="dodge-roll">
    <div class="combat-attribute-label">
      <i class="fas fa-dice-d20" />
      {localize('dodge')}
    </div>
    <div class="combat-attribute-value">
      {character.dodgeValue()}
    </div>
  </a>
</div>
<div class="combat-attributes flexrow">
  <div class="armor-class">
    <div class="combat-attribute-label">{localize('armorClass')}</div>
    <div class="combat-attribute-value">{character.armorClass}</div>
  </div>
  <div class="encumbarance">
    <div class="combat-attribute-label">
      {localize('encumbarance')}
    </div>
    <div class="combat-attribute-value">{character.encumbarance}</div>
  </div>
</div>

<style>
  .unarmedToggle {
    letter-spacing: 1px;
  }
</style>
